#pragma once

class Encoder {
 public:
  Encoder();
  Encoder(unsigned char transitionsPerRotation);

  virtual int GetPulseCount();
  virtual float GetPulsesPerSecond(float currentTimeMs);

  virtual float GetDistance();
  virtual float GetRevolutionsPerSecond(float currentTimeMs);

 protected:
  unsigned char transitionsPerRotation;
};
